/* Pavel Surynek, 2008 */
/* pavel.surynek@mff.cuni.cz */
/* mit_main.cpp */

/*
  An implementation of the algorithm for solving sliding box puzzles by
  Kornhauser, Miler, and Spirakis.
 */

#include "slider.h"
#include "mit.h"

SLIDER slider1, slider2;

int main(int UNUSED(argc), char **UNUSED(argv))
{
	FINE_SOLUTION solution, dummy_solution;

	clock_t begin, end;
	begin = clock();

	init_slider(0, 9, 9, 14, &slider1);
	copy_slider(&slider1, &slider2);
	swap_goal(1, 2, &slider1);

//	cycle_2_rotate_L(&slider1, dummy_solution);
	print_slider(&slider1);
	int trans = calculate_transpositions(&slider1);
	printf("Trans:%d\n", trans);

//	return 0;

	int robots[] = {3, 7, 5, 6};
	int positions[] = {5, 6, 7, 2};
/*
	move_4_transitively_cycle_1(&slider1, robots, positions, solution);
	print_slider(&slider1);
	print_slider(&slider2);

	print_fine_solution(solution);
	execute_fine_solution(&slider2, solution);
	print_slider(&slider2);
*/
/*
	print_slider(&slider1);
	cycle_1_rotate_L(&slider1, solution);
	cycle_2_rotate_L(&slider1, solution);
	cycle_1_rotate_R(&slider1, solution);
	cycle_2_rotate_R(&slider1, solution);
	print_slider(&slider1);
*/
/*
	print_slider(&slider1);
	generate_3_cycle(&slider1, 4, 5, 6, solution);
	print_slider(&slider1);
	execute_fine_solution(&slider2, solution);
	print_fine_solution(solution);
	print_slider(&slider2);
*/
	solve_slider_mit(&slider1, solution);
	print_slider(&slider1);
	execute_fine_solution(&slider1, solution);

	print_fine_solution(solution);

	print_slider(&slider1);

	end = clock();
	printf("Time:%.3f\n", (end - begin) / (double)CLOCKS_PER_SEC);

	return 0;
}
